/* **************************************************************************

  $Archive: /njcl_v2/src/com/novell/service/security/protocols/nls/LF.java $
  $Revision: 13 $
  $Modtime: 5/05/00 2:59p $

  Copyright (c) 1997-1998 Novell, Inc.  All Rights Reserved.

  THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL PROPRIETARY
  AND TRADE SECRET INFORMATION OF NOVELL, INC. ACCESS  TO  THIS  WORK IS
  RESTRICTED TO (I) NOVELL, INC.  EMPLOYEES WHO HAVE A NEED TO  KNOW HOW
  TO  PERFORM  TASKS WITHIN  THE SCOPE  OF  THEIR   ASSIGNMENTS AND (II)
  ENTITIES OTHER  THAN  NOVELL, INC.  WHO  HAVE ENTERED INTO APPROPRIATE
  LICENSE   AGREEMENTS.  NO  PART  OF  THIS WORK MAY BE USED, PRACTICED,
  PERFORMED COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,
  CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED,  RECAST, TRANSFORMED
  OR ADAPTED  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.  ANY USE
  OR EXPLOITATION  OF  THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE
  PERPETRATOR  TO CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/
package com.novell.service.security.protocols.nls;

import java.util.ListResourceBundle;

/** @internal
 *
 * The localization resource for this package.
 *
 * @author Jan Sture Nielsen
 * @version 1.0.0 98/03/04
 */
public class LF extends ListResourceBundle
{
   /**
    * list of keys which should NOT be localized
    */
   public final static String
      // user-interface
      LOGIN_DIALOG_TITLE               = "LOGIN_DIALOG_TITLE",
      CREATETOKENS_DIALOG_TITLE        = "CREATETOKENS_DIALOG_TITLE",
      MODIFYTOKENS_DIALOG_TITLE        = "MODIFYTOKENS_DIALOG_TITLE",
      VERIFYTOKENS_DIALOG_TITLE        = "VERIFYTOKENS_DIALOG_TITLE",
      LOGOUT_DIALOG_TITLE              = "LOGOUT_DIALOG_TITLE",
      LOGIN_GIF                        = "LOGIN_GIF",
      LOGOUT_GIF                       = "LOGOUT_GIF",
      CREATETOKENS_GIF                 = "CREATETOKENS_GIF",
      MODIFYTOKENS_GIF                 = "MODIFYTOKENS_GIF",
      VERIFYTOKENS_GIF                 = "VERIFYTOKENS_GIF",
      LDAP_NAME                        = "LDAP_NAME",
      LDAP_NAME_MNEMONIC               = "LDAP_NAME_MNEMONIC",
      LDAP_NAME_TOOLTIP                = "LDAP_NAME_TOOLTIP",
      LDAP_ICON                        = "LDAP_ICON",
      NDS_NAME                         = "NDS_NAME",
      NDS_NAME_MNEMONIC                = "NDS_NAME_MNEMONIC",
      NDS_NAME_TOOLTIP                 = "NDS_NAME_TOOLTIP",
      NDS_ICON                         = "NDS_ICON",
      BINDERY_NAME                     = "BINDERY_NAME",
      BINDERY_NAME_MNEMONIC            = "BINDERY_NAME_MNEMONIC",
      BINDERY_NAME_TOOLTIP             = "BINDERY_NAME_TOOLTIP",
      BINDERY_ICON                     = "BINDERY_ICON",
      NAME                             = "NAME",
      NAME_MNEMONIC                    = "NAME_MNEMONIC",
      NAME_TOOLTIP                     = "NAME_TOOLTIP",
      CONTEXT                          = "CONTEXT",
      CONTEXT_MNEMONIC                 = "CONTEXT_MNEMONIC",
      CONTEXT_TOOLTIP                  = "CONTEXT_TOOLTIP",
      TREE                             = "TREE",
      TREE_MNEMONIC                    = "TREE_MNEMONIC",
      TREE_TOOLTIP                     = "TREE_TOOLTIP",
      SERVER                           = "SERVER",
      SERVER_MNEMONIC                  = "SERVER_MNEMONIC",
      SERVER_TOOLTIP                   = "SERVER_TOOLTIP",
      PASSWORD                         = "PASSWORD",
      PASSWORD_MNEMONIC                = "PASSWORD_MNEMONIC",
      PASSWORD_TOOLTIP                 = "PASSWORD_TOOLTIP",
      NEW_PASSWORD                     = "NEW_PASSWORD",
      NEW_PASSWORD_MNEMONIC            = "NEW_PASSWORD_MNEMONIC",
      NEW_PASSWORD_TOOLTIP             = "NEW_PASSWORD_TOOLTIP",
      CONFIRM_PASSWORD                 = "CONFIRM_PASSWORD",
      CONFIRM_PASSWORD_MNEMONIC        = "CONFIRM_PASSWORD_MNEMONIC",
      CONFIRM_PASSWORD_TOOLTIP         = "CONFIRM_PASSWORD_TOOLTIP",
      OK                               = "OK",
      OK_MNEMONIC                      = "OK_MNEMONIC",
      OK_TOOLTIP                       = "OK_TOOLTIP",
      CANCEL                           = "CANCEL",
      CANCEL_MNEMONIC                  = "CANCEL_MNEMONIC",
      CANCEL_TOOLTIP                   = "CANCEL_TOOLTIP",
      HELP                             = "HELP",
      HELP_MNEMONIC                    = "HELP_MNEMONIC",
      HELP_TOOLTIP                     = "HELP_TOOLTIP",
      CREDENTIAL_INFO_ERROR            = "CREDENTIAL_INFO_ERROR",
      CREDENTIAL_INFO_ERROR_TITLE      = "CREDENTIAL_INFO_ERROR_TITLE",
      PREVIOUSLY_AUTHENTICATED         = "PREVIOUSLY_AUTHENTICATED",
      PREVIOUSLY_AUTHENTICATED_TITLE   = "PREVIOUSLY_AUTHENTICATED_TITLE",
      ANOTHER_AUTHENTICATED            = "ANOTHER_AUTHENTICATED",
      ANOTHER_AUTHENTICATED_TITLE      = "ANOTHER_AUTHENTICATED_TITLE",
	  HELP_ERROR_TITLE				   = "HELP_ERROR_TITLE",
	  HELP_ERROR_CLASS_NOT_FOUND	   = "HELP_ERROR_CLASS_NOT_FOUND",
	  HELP_ERROR_HELP_FILES_NOT_FOUND  = "HELP_ERROR_HELP_FILES_NOT_FOUND",
	  HELP_ERROR_INITIALIZATION		   = "HELP_ERROR_INITIALIZATION";      

   /**
    * accessor to the object array
    */
   public Object[][] getContents()
   {
      return contents;
   }

   /**
    * list of objects which should be localized
    */
   private final static Object[][] contents =
   {
      // BEGIN LOCALIZATION
      {LOGIN_DIALOG_TITLE,             "Login"},
      {CREATETOKENS_DIALOG_TITLE,      "Create Authentication Secrets"},
      {MODIFYTOKENS_DIALOG_TITLE,      "Modify Authentication Secrets"},
      {VERIFYTOKENS_DIALOG_TITLE,      "Verify Authentication Secrets"},
      {LOGOUT_DIALOG_TITLE,            "Logout"},
      {LOGIN_GIF,                      "/com/novell/service/session/xplat/login.gif"},
      {LOGOUT_GIF,                     "/com/novell/service/session/xplat/logout.gif"},
      {CREATETOKENS_GIF,               "/com/novell/service/session/xplat/create.gif"},
      {MODIFYTOKENS_GIF,               "/com/novell/service/session/xplat/modify.gif"},
      {VERIFYTOKENS_GIF,               "/com/novell/service/session/xplat/verify.gif"},
      {LDAP_NAME,                      "LDAP"},
      {LDAP_NAME_MNEMONIC,             "L"},
      {LDAP_NAME_TOOLTIP,              "Lightweight Directory Access Protocol"},
      {LDAP_ICON,                      ""},
      {NDS_NAME,                       "NDS"},
      {NDS_NAME_MNEMONIC,              "N"},
      {NDS_NAME_TOOLTIP,               "Novell Directory Service"},
      {NDS_ICON,                       ""},
      {BINDERY_NAME,                   "Bindery"},
      {BINDERY_NAME_MNEMONIC,          "B"},
      {BINDERY_NAME_TOOLTIP,           "NetWare Bindery"},
      {BINDERY_ICON,                   ""},
      {NAME,                           "Username"},
      {NAME_MNEMONIC,                  "U"},
      {NAME_TOOLTIP,                   "Target Name"},
      {CONTEXT,                        "Context"},
      {CONTEXT_MNEMONIC,               "C"},
      {CONTEXT_TOOLTIP,                "Target Context"},
      {SERVER,                         "Server"},
      {SERVER_MNEMONIC,                "S"},
      {SERVER_TOOLTIP,                 "Target Server"},
      {TREE,                           "Tree"},
      {TREE_MNEMONIC,                  "T"},
      {TREE_TOOLTIP,                   "Target Tree"},
      {PASSWORD,                       "Password"},
      {PASSWORD_MNEMONIC,              "P"},
      {PASSWORD_TOOLTIP,               "Enter Password"},
      {NEW_PASSWORD,                   "New Password"},
      {NEW_PASSWORD_MNEMONIC,          "e"},
      {NEW_PASSWORD_TOOLTIP,           "Enter New Password"},
      {CONFIRM_PASSWORD,               "Confirm New Password"},
      {CONFIRM_PASSWORD_MNEMONIC,      "f"},
      {CONFIRM_PASSWORD_TOOLTIP,       "Retype New Password"},
      {OK,                             "OK"},
      {OK_MNEMONIC,                    "O"},
      {OK_TOOLTIP,                     "Perform Operation"},
      {CANCEL,                         "Cancel"},
      {CANCEL_MNEMONIC,                "l"},
      {CANCEL_TOOLTIP,                 "Cancel Operation"},
      {HELP,                           "Help"},
      {HELP_MNEMONIC,                  "H"},
      {HELP_TOOLTIP,                   "Get Further Help"},
      {CREDENTIAL_INFO_ERROR,          "Credential information is incomplete or invalid."},
      {CREDENTIAL_INFO_ERROR_TITLE,    "Credential Information Error"},
      {PREVIOUSLY_AUTHENTICATED,       "You are already logged in to $t as $c. Do you still want to log in as $n?"},
      {PREVIOUSLY_AUTHENTICATED_TITLE, "Authentication Error"},
      {ANOTHER_AUTHENTICATED,          "You are already logged in to $t as $c. Do you still want to log in as $n?"},
      {ANOTHER_AUTHENTICATED_TITLE,    "Authentication Error"},
	  {HELP_ERROR_TITLE,		       "Online Help Error"},
	  {HELP_ERROR_CLASS_NOT_FOUND,	   "JavaHelp not found in classpath"},
	  {HELP_ERROR_HELP_FILES_NOT_FOUND,"HelpSet <com/novell/service/security/protocols/help/novellauthenticator.hs> not found"},
	  {HELP_ERROR_INITIALIZATION,	   "Error initializing JavaHelp"}
      // END LOCALIZATION
   };
}
